<template>
  <div class="browse spacing-top-mobile">
    <v-row class="pl-md-16 pr-md-16 pr-lg-0 pb-md-16 browse-section">
      <!-- Title -->
      <v-col cols="12" class="mt-16 hidden-lg-and-up text-center">
        <h2>{{ $t('appBar.rentStreetWear') }}</h2>
        <p>{{ totalProduct + ' ' + $t('common.products') }}</p>
      </v-col>

      <!-- Filter -->
      <v-col
        lg="1"
        cols="12"
        md="12"
        class="pt-lg-16 mt-lg-16 hidden-lg-and-up"
      >
        <v-row class="pa-0">
          <v-col cols="4">
            <h3
              class="
                                text-dim-grey
                                font-metropolis-regular
                                mt-3
                                text-center
                            "
            >
              {{ $t('common.sortBy') }}
            </h3>
          </v-col>
          <v-col cols="6" class="hidden-lg-and-up">
            <v-select
              v-model="filterSort"
              :items="sortList"
              item-text="name"
              item-value="id"
              solo
            />
          </v-col>

          <v-col cols="2" md="2" lg="12">
            <v-icon
              size="30"
              class="pointer mt-2 mt-md-0"
              color="white"
              @click="openFilterDrawer"
            >
              mdi-filter-variant
            </v-icon>
            <!-- <v-img
                            :src="filter"
                            max-width="29"
                            max-height="25"
                            class="pointer mt-3 mt-md-0"
                            @click="openFilterDrawer"
                        /> -->
          </v-col>
        </v-row>
      </v-col>

      <!-- PRODUCTS SECTION -->
      <v-col lg="9" md="12" class="d-none d-md-block">
        <v-row class="pt-md-16 mt-md-16 hidden-md-and-down">
          <v-col
            md="1"
            cols="6"
          >
            <h3 class="mt-3 text-dim-grey font-metropolis-regular">
              {{ $t('common.sortBy') }}
            </h3>
          </v-col>
          <v-col md="3" cols="6">
            <v-select
              v-model="filterSort"
              :items="sortList"
              item-text="name"
              item-value="id"
              solo
            />
          </v-col>
          <v-col cols="1">
            <v-icon
              :src="filter"
              max-width="29"
              max-height="25"
              class="mt-3 mt-md-1 filter-icon"
              @click="openFilterDrawer"
            >
              mdi-filter-outline
            </v-icon>
          </v-col>
          <v-col cols="1">
            <v-btn
              text
              class="ma-2 white--text"
              @click="clearFilters"
            >
              <v-icon left dark>
                mdi-close
              </v-icon>
              {{ $t('common.clear') }}
            </v-btn>
          </v-col>
          <v-col class="text-right">
            <h3 class="mt-3 text-dim-grey font-metropolis-regular">
              {{ totalProduct + ' ' + $t('common.products') }}
            </h3>
          </v-col>
        </v-row>
        <!-- SKELETON LOADER -->
        <v-row v-if="dataLoad">
          <v-col
            v-for="n in 15"
            :key="'loader-' + n"
            cols="6"
            md="4"
            class="mb-10"
          >
            <v-skeleton-loader
              id="dataLoader"
              :loading="dataLoading"
              class="mx-auto"
              max-width="auto"
              type="image"
            />

            <v-skeleton-loader
              class="pt-2"
              :loading="dataLoading"
              max-width="150"
              type="text"
            />

            <v-skeleton-loader
              :loading="dataLoading"
              max-width="100"
              type="text"
            />

            <v-skeleton-loader
              :loading="dataLoading"
              max-width="120"
              type="text"
            />
          </v-col>
        </v-row>

        <!-- PRODUCTS -->
        <v-row v-show="!dataLoad" :loading="dataLoading">
          <Draggable
            class="dragge"
            :sort="false"
            :list="products"
            :group="{
              name: `productCart`,
              pull: 'clone',
              put: false,
            }"
          >
            <v-col
              v-for="(p, prod) in products"
              :key="'product-' + prod"
              cols="6"
              md="4"
              class="mb-10"
            >
              <div class="product-container mb-5">
                <nuxt-link :to="'/products/' + p.slug">
                  <div class="hover-bg pointer">
                    <img
                      v-if="p.images.length > 1"
                      :src="p.images[1].url"
                      :alt="p.name"
                      class="image"
                    >
                  </div>
                  <!--  <div>
                                    <img class="drag-img" src="~/assets/images/drag.png" >
                                </div> -->
                </nuxt-link>
                <div class="product-wish">
                  <v-btn
                    v-if="
                      checkWishlist(p.id) === 'mdi-heart'
                    "
                    text
                    @click="removeFromWishlist(p.id)"
                  >
                    <v-icon
                      class="heart-icon-default"
                      v-html="checkWishlist(p.id)"
                    />
                  </v-btn>
                  <v-btn
                    v-else
                    text
                    @click="addToWishlist(p.id)"
                  >
                    <v-icon
                      class="heart-icon-default"
                      v-html="checkWishlist(p.id)"
                    />
                  </v-btn>
                </div>
                <div
                  v-if="p.total_inventories_count == 0"
                  class="product-rented font-syne-bold"
                >
                  <p class="rented-container">
                    Rented
                  </p>
                </div>
                <nuxt-link :to="'/products/' + p.slug">
                  <img
                    :src="p.images[0].url"
                    :alt="p.name"
                    class="image"
                  >
                </nuxt-link>

                <!-- <div class="middle">
                                <div class="text pointer" @click="addToBox(p)">
                                    {{ $t('buttons.addToBoxBtn') }}
                                </div>
                            </div> -->
              </div>
              <p class="product-title-text mb-1">
                <b>{{ p.brand.name }}</b> {{ p.name }}
              </p>
              <p class="product-desc-text">
                <!-- {{ p.size }}/{{ p.collection }}/ -->
                {{ p.pricing[0].currency_code }}
                {{ p.pricing[0].price }}
              </p>
            </v-col>
          </Draggable>
        </v-row>

        <v-row v-show="!dataLoad && products.length === 0">
          <v-col>
            <p>{{ $t('common.noProducts') }}</p>
          </v-col>
        </v-row>
        <!-- PAGINATION -->
        <v-row v-if="length > 1">
          <v-col>
            <v-pagination
              v-model="filterPage"
              :length="length"
              :total-visible="5"
              color="black"
            />
          </v-col>
        </v-row>
      </v-col>

      <!-- Disable Mobile Draggable -->
      <v-col lg="9" md="12" class="d-block d-md-none">
        <v-row class="pt-md-16 mt-md-16 hidden-md-and-down">
          <v-col
            md="1"
            cols="6"
          >
            <h3 class="mt-3 text-dim-grey font-metropolis-regular">
              {{ $t('common.sortBy') }}
            </h3>
          </v-col>
          <v-col md="3" cols="6">
            <v-select
              v-model="filterSort"
              :items="sortList"
              item-text="name"
              item-value="id"
              solo
            />
          </v-col>
          <v-col cols="1">
            <v-icon
              class="pointer mt-3 mt-md-0"
              color="white"
              @click="openFilterDrawer"
            >
              mdi-filter-variant
            </v-icon>
            <!--  <v-img
                            :src="filter"
                            max-width="29"
                            max-height="25"
                            class="pointer mt-3 mt-md-0"
                            @click="openFilterDrawer"
                        /> -->
          </v-col>
          <v-col class="text-right">
            <h3 class="mt-3 text-dim-grey font-metropolis-regular">
              {{ totalProduct + ' ' + $t('common.products') }}
            </h3>
          </v-col>
        </v-row>
        <!-- SKELETON LOADER -->
        <v-row v-if="dataLoad">
          <v-col
            v-for="n in 15"
            :key="'loader-' + n"
            cols="6"
            md="4"
            class="mb-10"
          >
            <v-skeleton-loader
              id="dataLoader"
              :loading="dataLoading"
              class="mx-auto"
              max-width="auto"
              type="image"
            />

            <v-skeleton-loader
              class="pt-2"
              :loading="dataLoading"
              max-width="150"
              type="text"
            />

            <v-skeleton-loader
              :loading="dataLoading"
              max-width="100"
              type="text"
            />

            <v-skeleton-loader
              :loading="dataLoading"
              max-width="120"
              type="text"
            />
          </v-col>
        </v-row>

        <!-- PRODUCTS -->
        <v-row v-show="!dataLoad" :loading="dataLoading">
          <v-col
            v-for="(p, prod) in products"
            :key="'product-' + prod"
            cols="6"
            md="4"
            class="mb-10"
          >
            <div class="product-container mb-5">
              <nuxt-link :to="'/products/' + p.slug">
                <div class="hover-bg pointer">
                  <img
                    v-if="p.images.length > 1"
                    :src="p.images[1].url"
                    :alt="p.name"
                    class="image"
                  >
                </div>
                <!--  <div>
                                    <img class="drag-img" src="~/assets/images/drag.png" >
                                </div> -->
              </nuxt-link>
              <div class="product-wish">
                <v-btn
                  v-if="checkWishlist(p.id) === 'mdi-heart'"
                  text
                  @click="removeFromWishlist(p.id)"
                >
                  <v-icon
                    class="heart-icon-default"
                    v-html="checkWishlist(p.id)"
                  />
                </v-btn>
                <v-btn v-else text @click="addToWishlist(p.id)">
                  <v-icon
                    class="heart-icon-default"
                    v-html="checkWishlist(p.id)"
                  />
                </v-btn>
              </div>
              <nuxt-link :to="'/products/' + p.slug">
                <img
                  :src="p.images[0].url"
                  :alt="p.name"
                  class="image"
                >
              </nuxt-link>

              <!-- <div class="middle">
                                <div class="text pointer" @click="addToBox(p)">
                                    {{ $t('buttons.addToBoxBtn') }}
                                </div>
                            </div> -->
            </div>
            <p class="product-title-text mb-1">
              <b>{{ p.brand.name }}</b> {{ p.name }}
            </p>
            <p class="product-desc-text">
              <!-- {{ p.size }}/{{ p.collection }}/ -->
              {{ p.pricing[0].currency_code }}
              {{ p.pricing[0].price }}
            </p>
          </v-col>
        </v-row>
        <v-row v-show="!dataLoad && products.length === 0">
          <v-col>
            <p>{{ $t('common.noProducts') }}</p>
          </v-col>
        </v-row>
        <!-- PAGINATION -->
        <v-row v-if="length > 1">
          <v-col class="pagination">
            <v-pagination
              v-model="filterPage"
              :length="length"
              :total-visible="4"
              color="black"
            />
          </v-col>
        </v-row>
      </v-col>

      <!-- BOX BAR -->
      <v-col md="3" class="black-bg overlay-box hidden-md-and-down">
        <Draggable
          :list="addCart"
          group="productCart"
          :move="checkMove"
          @change="seeChanges(addCart)"
        >
          <v-row class="drag-height">
            <v-col>
              <v-row class="drag-height-row">
                <v-col class="d-flex justify-center align-center">
                  <right-menu-option 
                    :route="currentRouteName"
                    :current-account-route="currentAccountRoute"
                    :route-query="currentRouteQuery"
                  />
                </v-col>
                <v-col
                  v-if="
                    cartItems.length === 0 &&
                      cartItemsCF.length === 0
                  "
                  cols="12"
                  class="d-flex justify-center mt-16"
                >
                  <v-img
                    :src="box"
                    max-width="98"
                    max-height="98"
                  />
                </v-col>
                <v-col cols="12" class="justify-center">
                  <p
                    v-if="
                      cartItems.length === 0 &&
                        cartItemsCF.length === 0
                    "
                    class="box-title-text text-center"
                  >
                    {{ $t('common.addToSideBox') }}
                  </p>
                  <v-row
                    v-if="cartItems.length === 0 &&
                          cartItemsCF.length === 0
                    "
                  >
                    <v-col class="d-flex justify-center item-center align-center">
                      <pick-for-me 
                        v-if="cartItems.length === 0 &&
                          cartItemsCF.length === 0
                        "
                      />
                    </v-col>
                  </v-row>
                  <div
                    v-else-if="
                      cartItems.length > 0 &&
                        cartItemsCF.length === 0 // enable return box
                    "
                  >
                    <!-- SUBSCRIBED PLAN -->
                    <v-row>
                      <v-col md="10" cols="10" offset="1">
                        <v-col class="pl-0">
                          <h3
                            v-if="planDetails"
                            class="font-syne-bold"
                          >
                            {{ planDetails.name }}
                          </h3>
                          <h3
                            v-else
                            class="font-syne-bold"
                          >
                            {{
                              $t('common.yourBox')
                            }}
                          </h3>
                          <!-- <p class="plan-text mb-1">
                                            1 x VIP /
                                            <span class="plan-white-text"
                                                >4 x Luxury & Designer</span
                                            >
                                        </p> -->
                        </v-col>
                        <v-divider />
                      </v-col>
                    </v-row>
                    <v-row
                      v-for="(i, items) of cartItems"
                      :key="'cart-' + items"
                    >
                      <v-col cols="3" offset="1">
                        <v-img
                          v-if="i.image"
                          :src="i.image.url"
                        />
                      </v-col>
                      <v-col cols="5">
                        <p
                          class="
                                                        product-title-text
                                                        mb-1
                                                    "
                        >
                          {{ i.brand.name }}
                          {{ i.name }}
                        </p>
                        <!-- <p class="product-desc-text mb-1">
                                        {{ i.size.name }} / {{ i.type.name }}
                                    </p> -->
                        <p
                          class="
                                                        product-desc-text
                                                        mb-1
                                                    "
                        >
                          {{ i.option.name }}
                        </p>
                        <p
                          class="
                                                        product-desc-text
                                                        mb-1
                                                    "
                        >
                          {{ currencyName }}
                          {{
                            i.price[currency].price
                          }}
                        </p>
                      </v-col>
                      <v-col>
                        <v-btn
                          icon
                          @click="removeFromBox(i.id)"
                        >
                          <v-icon>
                            mdi-close
                          </v-icon>
                        </v-btn>
                      </v-col>
                    </v-row>

                    <!-- TOTAL AMOUNT -->
                    <v-row>
                      <v-col md="10" cols="10" offset="1">
                        <v-divider />

                        <!-- ITEMS COUNT -->
                        <!-- <v-row>
                                        <v-col cols="6" class="pb-0">
                                            <p
                                                class="cart-text text-white mb-0"
                                            >
                                                {{ $t('cart.items') }}
                                            </p>
                                        </v-col>
                                        <v-col cols="6" class="text-right pb-0">
                                            <p
                                                class="cart-text text-white mb-0"
                                            >
                                                {{ cartItems.length }}/4
                                            </p>
                                        </v-col>
                                    </v-row> -->

                        <!-- ITEMS VALUE -->
                        <v-row>
                          <v-col
                            cols="5"
                            class="pb-0"
                          >
                            <p
                              class="
                                                                cart-text
                                                                text-white
                                                                mb-0
                                                            "
                            >
                              {{
                                $t(
                                  'cart.retailValue'
                                )
                              }}
                            </p>
                          </v-col>
                          <v-col
                            class="text-right pb-0"
                          >
                            <p
                              class="
                                                                cart-text
                                                                text-white
                                                                mb-0
                                                            "
                            >
                              {{ currencyName }}
                              {{
                                getTotalCartPrice
                              }}
                              {{
                                $t('common.of')
                              }}
                              {{ currencyName }}
                              {{
                                planDetails.purchase_amount
                              }}
                            </p>
                          </v-col>
                        </v-row>

                        <!-- RETAIL VALUE PROGRESS BAR -->
                        <v-row>
                          <v-col>
                            <v-progress-linear
                              :value="
                                getRetailValuePercentage
                              "
                              disabled
                              color="red"
                              height="10"
                            />
                          </v-col>
                        </v-row>

                        <!-- REMARKS -->
                        <v-row>
                          <v-col cols="9">
                            <p
                              class="
                                                                font-metropolis
                                                            "
                            >
                              {{
                                $t(
                                  'orders.remarks'
                                )
                              }}
                              {{ currencyName }}
                              {{
                                planDetails.purchase_amount
                              }}
                              {{
                                $t(
                                  'orders.remarks2'
                                )
                              }}
                            </p>
                          </v-col>
                          <v-col
                            class="
                                                            d-flex
                                                            justify-end
                                                        "
                          >
                            <v-tooltip
                              v-model="
                                extraFeeTooltip
                              "
                              right
                            >
                              <template
                                v-slot:activator="{
                                  on,
                                  attrs,
                                }"
                              >
                                <v-btn
                                  icon
                                  small
                                  v-bind="
                                    attrs
                                  "
                                  v-on="on"
                                >
                                  <v-icon
                                    color="lighten-1"
                                  >
                                    mdi-information-outline
                                  </v-icon>
                                </v-btn>
                              </template>
                              <span>Programmatic
                                tooltip</span>
                            </v-tooltip>
                          </v-col>
                        </v-row>

                        <!-- CART FEE -->
                        <!-- <v-row v-if="surcharges">
                                        <v-col cols="6" class="pt-0 pb-1">
                                            <p class="cart-text text-white">
                                                {{ $t('cart.extraFee') }}
                                                <v-tooltip
                                                    v-model="extraFeeTooltip"
                                                    right
                                                >
                                                    <template
                                                        v-slot:activator="{
                                                            on,
                                                            attrs,
                                                        }"
                                                    >
                                                        <v-btn
                                                            icon
                                                            x-small
                                                            v-bind="attrs"
                                                            v-on="on"
                                                        >
                                                            <v-icon
                                                                color="badge lighten-1"
                                                            >
                                                                mdi-information-outline
                                                            </v-icon>
                                                        </v-btn>
                                                    </template>
                                                    <span
                                                        >Programmatic
                                                        tooltip</span
                                                    >
                                                </v-tooltip>
                                            </p>
                                        </v-col>
                                        <v-col
                                            cols="6"
                                            class="text-right pt-0 pb-1"
                                        >
                                            <p class="cart-text text-red">
                                                {{ currencyName }}
                                                {{ surcharges }}
                                            </p>
                                        </v-col>
                                    </v-row> -->

                        <!-- CART TOTAL AMOUNT -->
                        <!-- <v-row>
                                        <v-col cols="6" class="pt-1 pb-1">
                                            <h3>
                                                {{ $t('cart.total') }}
                                            </h3>
                                        </v-col>
                                        <v-col
                                            cols="6"
                                            class="text-right pt-1 pb-1"
                                        >
                                            <h3>
                                                {{ currencyName }}
                                                {{
                                                    getTotalCartPrice +
                                                    surcharges
                                                }}
                                            </h3>
                                        </v-col>
                                    </v-row> -->

                        <!-- CHECKOUT BUTTON -->
                        <v-row>
                          <v-col>
                            <v-btn
                              class="
                                                                lowercase
                                                                br-0
                                                                pl-10
                                                                pr-10
                                                                font-syne-bold
                                                            "
                              color="badge"
                              block
                              large
                              :loading="
                                isButtonDisabled
                              "
                              :disabled="
                                isButtonDisabled
                              "
                              @click="goCheckout"
                            >
                              {{
                                $t(
                                  'buttons.checkoutBtn'
                                )
                              }}
                            </v-btn>
                          </v-col>
                        </v-row>
                      </v-col>
                    </v-row>
                  </div>

                  <!-- If there is item in cart and also pending partial item" -->
                  <div
                    v-else-if="
                      cartItems.length > 0 &&
                        cartItemsCF.length > 0 // enable return box
                    "
                  >
                    <v-row>
                      <v-col cols="10" offset="1">
                        <v-expansion-panels
                          v-model="panel"
                        >
                          <v-expansion-panel
                            v-for="(item, i) in 1"
                            :key="i"
                          >
                            <v-expansion-panel-header>
                              {{
                                $t(
                                  'common.holdingItems'
                                )
                              }}
                            </v-expansion-panel-header>
                            <v-expansion-panel-content>
                              <v-row
                                v-for="(
                                  cf, items
                                ) of cartItemsCF"
                                :key="
                                  'cart-' +
                                    items
                                "
                              >
                                <v-col cols="5">
                                  <v-img
                                    v-if="
                                      cf.image
                                    "
                                    :src="
                                      cf
                                        .image
                                        .url
                                    "
                                  />
                                </v-col>
                                <v-col cols="7">
                                  <p
                                    class="
                                                                            product-title-text
                                                                            mb-1
                                                                        "
                                  >
                                    {{
                                      cf
                                        .brand
                                        .name
                                    }}
                                    {{
                                      cf.name
                                    }}
                                  </p>
                                  <p
                                    class="
                                                                            product-desc-text
                                                                            mb-1
                                                                        "
                                  >
                                    {{
                                      cf.variant
                                    }}
                                  </p>
                                  <p
                                    class="
                                                                            product-desc-text
                                                                            mb-1
                                                                        "
                                  >
                                    {{
                                      currencyName
                                    }}
                                    {{
                                      cf
                                        .price[
                                          currency
                                        ]
                                        .price
                                    }}
                                  </p>
                                </v-col>
                              </v-row>
                            </v-expansion-panel-content>
                          </v-expansion-panel>
                        </v-expansion-panels>
                        <v-divider />
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col md="10" cols="10" offset="1">
                        <v-col class="pl-0">
                          <h3
                            v-if="planDetails"
                            class="font-syne-bold"
                          >
                            {{ planDetails.name }}
                          </h3>
                          <h3
                            v-else
                            class="font-syne-bold"
                          >
                            {{
                              $t('common.yourBox')
                            }}
                          </h3>
                          <!-- <p class="plan-text mb-1">
                                            1 x VIP /
                                            <span class="plan-white-text"
                                                >4 x Luxury & Designer</span
                                            >
                                        </p> -->
                        </v-col>
                        <v-divider />
                      </v-col>
                    </v-row>
                    <v-row
                      v-for="(i, items) of cartItems"
                      :key="'cart-' + items"
                    >
                      <v-col cols="3" offset="1">
                        <v-img
                          v-if="i.image"
                          :src="i.image.url"
                        />
                      </v-col>
                      <v-col cols="5">
                        <p
                          class="
                                                        product-title-text
                                                        mb-1
                                                    "
                        >
                          {{ i.brand.name }}
                          {{ i.name }}
                        </p>
                        <!-- <p class="product-desc-text mb-1">
                                        {{ i.size.name }} / {{ i.type.name }}
                                    </p> -->
                        <p
                          class="
                                                        product-desc-text
                                                        mb-1
                                                    "
                        >
                          {{ i.option.name }}
                        </p>
                        <p
                          class="
                                                        product-desc-text
                                                        mb-1
                                                    "
                        >
                          {{ currencyName }}
                          {{
                            i.price[currency].price
                          }}
                        </p>
                      </v-col>
                      <v-col>
                        <v-btn
                          icon
                          @click="removeFromBox(i.id)"
                        >
                          <v-icon>
                            mdi-close
                          </v-icon>
                        </v-btn>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col
                        cols="5"
                        offset="1"
                        class="pb-0"
                      >
                        <p
                          class="
                                                        cart-text
                                                        text-white
                                                        mb-0
                                                    "
                        >
                          {{ $t('cart.retailValue') }}
                        </p>
                      </v-col>
                      <v-col class="text-right pb-0 mr-8">
                        <p
                          class="
                                                        cart-text
                                                        text-white
                                                        mb-0
                                                    "
                        >
                          {{ currencyName }}
                          {{ getTotalCartPrice }}
                          {{ $t('common.of') }}
                          {{ currencyName }}
                          {{
                            planDetails.purchase_amount
                          }}
                        </p>
                      </v-col>
                    </v-row>

                    <!-- RETAIL VALUE PROGRESS BAR -->
                    <v-row>
                      <v-col cols="10" offset="1">
                        <v-progress-linear
                          :value="
                            getRetailValuePercentage
                          "
                          disabled
                          color="red"
                          height="10"
                        />
                      </v-col>
                    </v-row>

                    <!-- REMARKS -->
                    <v-row>
                      <v-col cols="8" offset="1">
                        <p class="font-metropolis">
                          {{ $t('orders.remarks') }}
                          {{ currencyName }}
                          {{
                            planDetails.purchase_amount
                          }}
                          {{ $t('orders.remarks2') }}
                        </p>
                      </v-col>
                      <v-col
                        class="d-flex justify-end mr-8"
                      >
                        <v-tooltip
                          v-model="extraFeeTooltip"
                          right
                        >
                          <template
                            v-slot:activator="{
                              on,
                              attrs,
                            }"
                          >
                            <v-btn
                              icon
                              small
                              v-bind="attrs"
                              v-on="on"
                            >
                              <v-icon
                                color="lighten-1"
                              >
                                mdi-information-outline
                              </v-icon>
                            </v-btn>
                          </template>
                          <span>Programmatic
                            tooltip</span>
                        </v-tooltip>
                      </v-col>
                    </v-row>

                    <!-- CART FEE -->
                    <!-- <v-row v-if="surcharges">
                                        <v-col cols="6" class="pt-0 pb-1">
                                            <p class="cart-text text-white">
                                                {{ $t('cart.extraFee') }}
                                                <v-tooltip
                                                    v-model="extraFeeTooltip"
                                                    right
                                                >
                                                    <template
                                                        v-slot:activator="{
                                                            on,
                                                            attrs,
                                                        }"
                                                    >
                                                        <v-btn
                                                            icon
                                                            x-small
                                                            v-bind="attrs"
                                                            v-on="on"
                                                        >
                                                            <v-icon
                                                                color="badge lighten-1"
                                                            >
                                                                mdi-information-outline
                                                            </v-icon>
                                                        </v-btn>
                                                    </template>
                                                    <span
                                                        >Programmatic
                                                        tooltip</span
                                                    >
                                                </v-tooltip>
                                            </p>
                                        </v-col>
                                        <v-col
                                            cols="6"
                                            class="text-right pt-0 pb-1"
                                        >
                                            <p class="cart-text text-red">
                                                {{ currencyName }}
                                                {{ surcharges }}
                                            </p>
                                        </v-col>
                                    </v-row> -->

                    <!-- CART TOTAL AMOUNT -->
                    <!-- <v-row>
                                        <v-col cols="6" class="pt-1 pb-1">
                                            <h3>
                                                {{ $t('cart.total') }}
                                            </h3>
                                        </v-col>
                                        <v-col
                                            cols="6"
                                            class="text-right pt-1 pb-1"
                                        >
                                            <h3>
                                                {{ currencyName }}
                                                {{
                                                    getTotalCartPrice +
                                                    surcharges
                                                }}
                                            </h3>
                                        </v-col>
                                    </v-row> -->

                    <!-- CHECKOUT BUTTON -->
                    <v-row>
                      <v-col cols="10" offset="1">
                        <v-btn
                          class="
                                                        lowercase
                                                        br-0
                                                        pl-10
                                                        pr-10
                                                        font-syne-bold
                                                    "
                          color="badge"
                          block
                          large
                          :loading="isButtonDisabled"
                          :disabled="isButtonDisabled"
                          @click="goCheckout"
                        >
                          {{
                            $t(
                              'buttons.checkoutBtn'
                            )
                          }}
                        </v-btn>
                      </v-col>
                    </v-row>
                  </div>

                  <!-- RETURN BOX -->
                  <div v-else>
                    <!-- CURRENT ORDER ITEMS -->
                    <v-row>
                      <v-col cols="10" offset="1">
                        <v-expansion-panels
                          v-model="panel"
                        >
                          <v-expansion-panel
                            v-for="(item, i) in 1"
                            :key="i"
                          >
                            <v-expansion-panel-header>
                              {{
                                $t(
                                  'common.holdingItems'
                                )
                              }}
                            </v-expansion-panel-header>
                            <v-expansion-panel-content>
                              <v-row
                                v-for="(
                                  cf, items
                                ) of cartItemsCF"
                                :key="
                                  'cart-' +
                                    items
                                "
                              >
                                <v-col cols="5">
                                  <v-img
                                    v-if="
                                      cf.image
                                    "
                                    :src="
                                      cf
                                        .image
                                        .url
                                    "
                                  />
                                </v-col>
                                <v-col cols="7">
                                  <p
                                    class="
                                                                            product-title-text
                                                                            mb-1
                                                                        "
                                  >
                                    {{
                                      cf
                                        .brand
                                        .name
                                    }}
                                    {{
                                      cf.name
                                    }}
                                  </p>
                                  <p
                                    class="
                                                                            product-desc-text
                                                                            mb-1
                                                                        "
                                  >
                                    {{
                                      cf.variant
                                    }}
                                  </p>
                                  <p
                                    class="
                                                                            product-desc-text
                                                                            mb-1
                                                                        "
                                  >
                                    {{
                                      currencyName
                                    }}
                                    {{
                                      cf
                                        .price[
                                          currency
                                        ]
                                        .price
                                    }}
                                  </p>
                                </v-col>
                              </v-row>
                            </v-expansion-panel-content>
                          </v-expansion-panel>
                        </v-expansion-panels>
                        <v-divider />
                      </v-col>
                    </v-row>
                    <v-row
                      v-if="cartItemsCF[0].status !== 8"
                    >
                      <v-col
                        cols="12"
                        class="
                                                    d-flex
                                                    justify-center
                                                    mt-16
                                                "
                      >
                        <v-img
                          :src="box"
                          max-width="98"
                          max-height="98"
                        />
                      </v-col>
                      <v-col cols="12">
                        <p
                          class="
                                                        box-title-text
                                                        text-center
                                                    "
                        >
                          {{ $t('common.returnBox') }}
                        </p>
                      </v-col>
                    </v-row>
                    <v-row
                      v-if="cartItemsCF[0].status !== 8"
                    >
                      <v-col cols="10" offset="1">
                        <v-expansion-panels
                          v-model="menu1"
                        >
                          <v-expansion-panel>
                            <v-expansion-panel-header
                              class="
                                                                font-metropolis-regular
                                                            "
                            >
                              {{
                                deliveryDate !=
                                  ''
                                  ? formatDate(
                                    deliveryDate
                                  )
                                  : $t(
                                    'form.deliveryDate.text'
                                  )
                              }}
                            </v-expansion-panel-header>
                            <v-expansion-panel-content>
                              <client-only>
                                <date-picker
                                  v-model="
                                    deliveryDate
                                  "
                                  format="yyyy-MM-dd"
                                  :disabled-dates="
                                    disabledDates
                                  "
                                  :inline="
                                    true
                                  "
                                  @selected="
                                    menu1 = false
                                  "
                                />
                              </client-only>
                            </v-expansion-panel-content>
                          </v-expansion-panel>
                        </v-expansion-panels>
                      </v-col>
                    </v-row>
                    <v-form
                      v-show="pageLoaded"
                      ref="returnBoxForm"
                      lazy-validation
                      @submit.prevent
                    >
                      <!-- DELIVERY TIME -->
                      <v-row
                        v-if="
                          cartItemsCF[0].status !== 8
                        "
                      >
                        <v-col cols="10" offset="1">
                          <v-select
                            ref="deliveryTime"
                            v-model="
                              form.deliveryTime
                                .value
                            "
                            :label="
                              $t(
                                'form.deliveryTime.text'
                              )
                            "
                            :items="timeslots"
                            item-text="name"
                            item-value="id"
                            :error-messages="
                              form.deliveryTime
                                .error
                            "
                            :rules="[requiredRules]"
                          >
                            <template
                              v-slot:append
                            >
                              <v-icon>
                                mdi-chevron-down
                              </v-icon>
                            </template>
                          </v-select>
                        </v-col>
                      </v-row>
                      <v-row
                        v-if="
                          cartItemsCF[0].status !== 8
                        "
                      >
                        <v-col cols="10" offset="1">
                          <v-btn
                            class="
                                                            lowercase
                                                            br-0
                                                            pl-10
                                                            pr-10
                                                            font-syne-bold
                                                        "
                            color="badge"
                            block
                            large
                            :loading="
                              isButtonDisabled
                            "
                            :disabled="
                              isButtonDisabled
                            "
                            @click="
                              validateForm(
                                cartItemsCF[0]
                                  .orderId
                              )
                            "
                          >
                            {{
                              $t(
                                'buttons.returnBoxBtn'
                              )
                            }}
                          </v-btn>
                        </v-col>
                      </v-row>
                    </v-form>
                  </div>
                </v-col>
              </v-row>
            </v-col>
          </v-row>
        </Draggable>
      </v-col>
    </v-row>
  </div>
</template>

<script lang="ts">
import { Vue, Component, Watch } from 'nuxt-property-decorator'
import { mapGetters } from 'vuex'
import { Debounce } from 'lodash-decorators'
import moment from 'moment'

@Component({
    head() {
        return {
            title: 'Rent Streetwear',
        }
    },

    computed: {
        ...mapGetters({
            currency: 'currency/getCurrency',
            currencyName: 'currency/getCurrencyName',
            getFilter: 'filter/getFilter',
            cartItems: 'cart/getCartItems',
            cartItemsCF: 'cart/getCartItemsCF',
            cartPrice: 'cart/getCartPrice',
            retailValue: 'cart/getRetailValue',
            checkWishlist: 'wishlist/checkWishlist',
            planDetails: 'subscription/getPlanDetails',
        }),
    },
})
export default class Browse extends Vue {
    // Data
    activeTab: Number = 0
    $refs!: { returnBoxForm: HTMLFormElement }
    ref: any = this.$refs
    getFilter!: Function
    cartPrice!: Function
    retailValue!: Function
    pageLoaded: boolean = false
    deleteItem: any = []
    filter: String = require('~/assets/images/filterNew.svg')
    box: String = require('~/assets/images/cartbox.png')
    dataLoad: Boolean = true
    dataLoading: Boolean = true
    extraFeeTooltip: Boolean = false
    isButtonDisabled: Boolean = false
    totalProduct: Number = 0
    sortList: any = [
        {
            id: 'price&false',
            name: 'Price: Low to High',
        }, // 0 = asc product price
        {
            id: 'price&true',
            name: 'Price: High to Low',
        }, // 1 = desc product price
        /*         {
            id: 'created_at&true',
            name: 'Newest',
        }, // 2 = desc product created */
        {
            id: 'created_at&false',
            name: 'Oldest',
        }, // 3 = asc product created
        {
            id: 'new_arrival&true',
            name: 'New Arrivals',
        }, // 4 = new arrivals
        {
            id: 'most_popular&true',
            name: 'Most Popular',
        }, // 5 = most popular
        /*  {
            id: 'most_popular&false',
            name: 'Least Popular',
        }, // 6 = least popular,
        {
            id: 'name&false',
            name: 'Product Name',
        }, // 7 = asc product name */
    ]

    holidays: any = []
    menu1: any = false
    filterable: any = []
    products: any = []
    addCart: any = []
    cartList: any = []
    sizesList: any = []
    page: number = 1
    length: number = 1
    message: any = null
    color: String = ''
    icon: String = ''
    currency!: number
    panel: number = 0
    form: { [key: string]: any } = {
        deliveryTime: {
            value: '',
            error: null,
            requestKey: 'delivery_time',
        },
    }

    timeslots: any = []
    todayDate: any = new Date().setDate(new Date().getDate())
    tomorrowDate: any = new Date(this.todayDate)
    disabledDates: any = {
        to: this.tomorrowDate,
        dates: this.holidays,
        days: [6, 0], // Disable Saturday's and Sunday's
    }

    deliveryDate: any = ''

    // Methods
    get currentRouteName () {
      return this.$route.name
    }

    get currentRouteQuery () {
      return this.$route.query.s
    }
    
    currentAccountRoute () {
      this.activeTab = 0
    }

    seeChanges(val) {
        this.$store.commit('dialogbar/setSizes', val[0].stocks)
        this.cartList = {
            text: val[0].slug,
            name: val[0].name,
            image: val[0].images[0].url,
            type: val[0].id,
            products: val[0],
        }
        this.$store.dispatch('dialogbar/displayDialogBar', this.cartList)
        this.addCart = []
    }

    checkMove() {
        return false
    }

    openFilterDrawer() {
        this.$store.commit('drawerbar/setFilterDrawer', true)
    }

    formatDate(date) {
        return moment(date).format('yyyy-MM-DD')
    }

    get getTotalCartPrice() {
        return this.cartPrice(this.currency)
    }

    get getRetailValuePercentage() {
        const amount = 3000
        return this.retailValue(amount, this.currency)
    }

    requiredRules(v: string) {
        if (v) {
            return true
        } else {
            return this.$t('form.validation.required')
        }
    }

    validateForm(orderId: number) {
        if (typeof this.$refs === 'undefined') {
            return
        }
        setTimeout(() => {
            const valid = this.$refs.returnBoxForm.validate()

            if (valid) {
                if (!this.deliveryDate) {
                    const val = {
                        text: this.$t('notification.date.required'),
                        color: 'white',
                        icon: 'mdi-alert',
                    }
                    this.$store.dispatch('snackbar/displaySnackBar', val)
                    this.isButtonDisabled = false
                } else {
                    this.goReturnBox(orderId)
                }
            }
        }, 300)
    }

    goReturnBox(orderId: number) {
        this.isButtonDisabled = true

        // return cart api
        this.$api.timeslot
            .allocate(
                orderId,
                moment(this.deliveryDate).format('yyyy-MM-DD'),
                this.form.deliveryTime.value
            )
            .then(() => {
                const val = {
                    text: this.$t('notification.return.success'),
                    color: 'green',
                    icon: 'mdi-check',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)

                this.isButtonDisabled = false
            })
            .catch((error) => {
                // Get errors object
                if (error.response.status === 400) {
                    const val = {
                        text: error.response.data.message,
                        color: 'red',
                        icon: 'mdi-alert',
                    }
                    this.$store.dispatch('snackbar/displaySnackBar', val)
                }
                // Reopen button
                this.isButtonDisabled = false
            })
    }

    async getTimeslots() {
        const timeslots = await this.$api.timeslot.getTimeslots()
        if (timeslots.data.data.length > 0) {
            for (const key of timeslots.data.data) {
                // return timeslots
                if (key.type_id === 2) {
                    const convertStartTime = moment().format(
                        'YYYY-MM-DD ' + key.start_time
                    )
                    const newStartTime = moment(convertStartTime)
                        .add(8, 'hours')
                        .format('HH:mm')

                    const convertEndTime = moment().format(
                        'YYYY-MM-DD ' + key.end_time
                    )
                    const newEndTime = moment(convertEndTime)
                        .add(8, 'hours')
                        .format('HH:mm')

                    const suffixStart =
                        parseInt(newStartTime) >= 12 ? 'PM' : 'AM'
                    const suffixEnd = parseInt(newEndTime) >= 12 ? 'PM' : 'AM'
                    const timeStart =
                        ((parseInt(newStartTime) + 11) % 12) + 1 + suffixStart
                    const timeEnd =
                        ((parseInt(newEndTime) + 11) % 12) + 1 + suffixEnd

                    const obj = {
                        id: key.id,
                        name: timeStart + ' - ' + timeEnd,
                    }
                    this.timeslots.push(obj)
                }
            }
        }
    }

    @Debounce(500)
    async addToWishlist(id: number) {
        if (!this.$cookies.get('t')) {
            this.message = this.$t('auth.unAuthenticate')
            this.color = 'red'
            this.icon = 'mdi-close-circle'
        } else {
            const response = await this.$api.wishlist.addWishlist(id)

            if (response.data) {
                this.$store.dispatch('wishlist/addToWishlist', response.data)
                this.message = this.$t('notification.wishlist.added')
                this.color = 'green'
                this.icon = 'mdi-check'
            }
        }

        const val = {
            text: this.message,
            color: this.color,
            icon: this.icon,
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)
    }

    @Debounce(500)
    async removeFromWishlist(id: number) {
        if (!this.$cookies.get('t')) {
            this.message = this.$t('auth.wishlistAuth')
            this.color = 'red'
            this.icon = 'mdi-close-circle'
        } else {
            const deleteResponse = await this.$api.wishlist.deleteWishlist(id)

            if (deleteResponse) {
                this.$store.dispatch('wishlist/removeFromWishlist', id)
                this.message = this.$t('notification.wishlist.removed')
                this.color = 'green'
                this.icon = 'mdi-check'
            }
        }

        const val = {
            text: this.message,
            color: this.color,
            icon: this.icon,
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)
    }

    addToBox(product: {}) {
        this.$store.dispatch('cart/addToCart', product)
        const val = {
            text: this.$t('notification.cart.added'),
            color: 'green',
            icon: 'mdi-check',
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)
    }

    async removeFromBox(product: any = {}) {
        
        // push product id to delete array
        if (!this.deleteItem.includes(product)) {
            this.deleteItem.push(product)
            
        }

        // delete from cart
        const response = await this.$api.cart.remove(product, 1)

        if (response.data) {
            this.$store.dispatch('cart/removeFromCart', product)
            const val: {} = {
                text: this.$t('notification.cart.removed'),
                color: 'green',
                icon: 'mdi-check',
            }
            this.$store.dispatch('snackbar/displaySnackBar', val)
           
            // remove product id from delete array
            if (this.deleteItem.includes(product)) {
                const index = this.deleteItem.indexOf(product)
                this.deleteItem.splice(index, 1)
            }
        } else {
            const val: {} = {
                text: this.$t('notification.cart.removed_failed'),
                color: 'red',
                icon: 'mdi-alert',
            }
            this.$store.dispatch('snackbar/displaySnackBar', val)
        }
    }

    goCheckout() {
        this.$router.push({ path: '/checkout' })
    }

    @Debounce(500)
    async getProducts() {
        this.dataLoad = true
        const response = await this.$api.product.getProducts(
            [1], // type 1 = rental
            this.filterSearch,
            this.filterSort,
            this.filterType,
            this.filterCategory,
            this.filterBrand,
            this.filterGender,
            this.filterVariant,
            this.filterPrice,
            this.filterPage
        )
        if (response.data) {
            this.products = response.data.data
            this.filterPage = this.$cookies.get('cp')
            this.length = response.data.meta.last_page
            this.totalProduct = response.data.meta.total
            this.dataLoad = false
        }
    }

    async getFilterable() {
        const response = await this.$api.product.filterable()
        if (response) {
            // Store types
            this.$store.commit('filter/setTypesMutation', response.data.types)

            // Store categories
            this.$store.commit(
                'filter/setCategoriesMutation',
                response.data.categories
            )

            // Store brands
            this.$store.commit('filter/setBrandsMutation', response.data.brands)

            // Store genders
            this.$store.commit(
                'filter/setGendersMutation',
                response.data.genders
            )

            // Store variants
            this.$store.commit(
                'filter/setVariantsMutation',
                response.data.variants
            )
        }
    }

    clearFilters() {
        this.$store.commit('filter/clearFilters')
    }

    // Computed

    get filterSearch() {
        return this.getFilter('search')
    }

    get filterPage() {
        return this.getFilter('page')
    }

    set filterPage(value: number) {
        this.$store.commit('filter/setFilterPageMutation', value)
    }

    get filterSort() {
        return this.getFilter('sort')
    }

    set filterSort(value: string) {
        this.$store.commit('filter/setFilterSortMutation', value)
    }

    get filterType() {
        return this.getFilter('type')
    }

    get filterCategory() {
        return this.getFilter('category')
    }

    get filterBrand() {
        return this.getFilter('brand')
    }

    get filterGender() {
        return this.getFilter('gender')
    }

    get filterVariant() {
        return this.getFilter('variant')
    }

    get filterPrice() {
        return this.getFilter('price')
    }

    // watch
    @Watch('filterPage')
    triggerPaginate() {
        this.dataLoad = true
        this.dataLoading = true
        this.$cookies.set('cp', this.filterPage)
        this.getProducts()
    }

    @Watch('filterSearch')
    triggerFilterSearch() {
        this.dataLoad = true
        this.dataLoading = true
        this.getProducts()
    }

    @Watch('filterSort')
    triggerFilterSort() {
        this.dataLoad = true
        this.dataLoading = true
        this.getProducts()
    }

    @Watch('filterType')
    triggerfilterType() {
        this.dataLoad = true
        this.dataLoading = true
        this.getProducts()
    }

    @Watch('filterCategory')
    triggerFilterCategory() {
        this.dataLoad = true
        this.dataLoading = true
        this.getProducts()
    }

    @Watch('filterBrand')
    triggerFilterBrand() {
        this.dataLoad = true
        this.dataLoading = true
        this.getProducts()
    }

    @Watch('filterGender')
    triggerGenderCategory() {
        this.dataLoad = true
        this.dataLoading = true
        this.getProducts()
    }

    @Watch('filterVariant')
    triggerFilterVariant() {
        this.dataLoad = true
        this.dataLoading = true
        this.getProducts()
    }

    @Watch('filterPrice')
    triggerFilterPrice() {
        this.dataLoad = true
        this.dataLoading = true
        this.getProducts()
    }

    async getHolidays() {
        const holidays = await this.$api.holiday.getHolidays()
        if (holidays.data.data.length > 0) {
            for (const key of holidays.data.data) {
                this.holidays.push(new Date(key.from))
            }
        }
    }

    mounted() {
        this.filterSort = 'new_arrival&true'

        // Clear filters
        if (!this.$route.query.brands && !this.filterSearch) {
            // this.clearFilters()
        }

        this.getTimeslots()
        this.getHolidays()
        if (typeof this.$refs !== 'undefined') {
            this.ref = this.$refs
            this.pageLoaded = true
        }
        // Get filterable
        this.getFilterable()

        // Get products
        this.getProducts()

        if (typeof this.$refs !== 'undefined') {
            this.ref = this.$refs
            this.pageLoaded = true
        }
        /* var value = this.cartItemsCF.reverse()  */
    }
}
</script>
